//+------------------------------------------------------------------+
//|                                                           CC.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"
string Indicator_Name="CC:    ";
int Objs=0;double x_buf_usk;double kp[10];
double k; double max_k_sl; string para_f; int kob;
string usk;string vp[10];string ob_f;string ob_f2;string x_buf_vp;
#property indicator_separate_window
#property indicator_buffers 8
//---- parameters
 int MA_Method=3;int Price2=6;bool USD = 1;bool EUR = 1;bool GBP = 1;bool CHF = 1;bool JPY = 1;
 color Color_USD = LimeGreen;color Color_EUR = Blue;color Color_GBP = Red;color Color_CHF = Chocolate;color Color_JPY = Maroon;
 int Line_Thickness = 2;int Bars.Count = 100;
 int mn_per = 12;int mn_fast = 3;// for monthly
 int w_per = 9;int w_fast = 3;// for weekly
 int d_per = 5;int d_fast = 3;// for daily
 extern int h4_per = 18;extern int h4_fast = 5;// for H4
 int h1_per = 24;int h1_fast = 8;// for H1
 int m30_per = 16;int m30_fast = 2;// for M30
 int m15_per = 16;int m15_fast = 4;// for M15
 int m5_per = 12;int m5_fast = 3;// for M5
 int m1_per = 30;int m1_fast = 10;color color_val = DarkBlue;// for M1
double arrUSD[];double arrEUR[];double arrGBP[];double arrCHF[];double arrJPY[];color col_tek;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if (USD)Indicator_Name=StringConcatenate(Indicator_Name," USD");
   if (EUR)Indicator_Name=StringConcatenate(Indicator_Name," EUR");if (GBP)Indicator_Name=StringConcatenate(Indicator_Name," GBP");
   if (CHF)Indicator_Name=StringConcatenate(Indicator_Name," CHF");if (JPY)Indicator_Name=StringConcatenate(Indicator_Name," JPY");
   IndicatorShortName(Indicator_Name);int cur=0; int st=23;
   if (USD){sl("~",cur,Color_USD);cur+=st;}
   if (EUR){sl("~",cur,Color_EUR);cur+=st;}
   if (GBP){sl("~",cur,Color_GBP);cur+=st;}
   if (CHF){sl("~",cur,Color_CHF);cur+=st;}
   if (JPY){sl("~",cur,Color_JPY);cur+=st;}
      
   int width=0;
   if(0>StringFind(Symbol(),"USD",0))width=1;SetIndexStyle(0,DRAW_LINE,DRAW_LINE,width,Color_USD);SetIndexBuffer(0,arrUSD);SetIndexLabel(0, "USD");//else width=Line_Thickness;
   if(0>StringFind(Symbol(),"EUR",0))width=1;SetIndexStyle(1,DRAW_LINE,DRAW_LINE,width,Color_EUR);SetIndexBuffer(1,arrEUR);SetIndexLabel(1, "EUR");//else width=Line_Thickness;
   if(0>StringFind(Symbol(),"GBP",0))width=1;SetIndexStyle(2,DRAW_LINE,DRAW_LINE,width,Color_GBP);SetIndexBuffer(2,arrGBP);SetIndexLabel(2, "GBP");//else width=Line_Thickness;
   if(0>StringFind(Symbol(),"CHF",0))width=1;else width=Line_Thickness;SetIndexStyle(3,DRAW_LINE,STYLE_DOT,width,Color_CHF);SetIndexBuffer(3,arrCHF);SetIndexLabel(3, "CHF"); 
   if(0>StringFind(Symbol(),"JPY",0))width=1;else width=Line_Thickness;SetIndexStyle(4,DRAW_LINE,STYLE_DOT,width,Color_JPY);SetIndexBuffer(4,arrJPY);SetIndexLabel(4, "JPY"); 
   
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=0; i<Objs; i++){
      if(!ObjectDelete(Indicator_Name+i))
         Print("error: code #",GetLastError());
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;int counted_bars=IndicatorCounted();if(counted_bars>0) counted_bars--;limit=Bars-counted_bars+Bars.Count;int Slow,Fast;color wt;
     switch(Period())
       {
         case 1:     Slow = m1_per; Fast = m1_fast; break;
         case 5:     Slow = m5_per; Fast = m5_fast; break;
         case 15:    Slow = m15_per;Fast = m15_fast; break;
         case 30:    Slow = m30_per;Fast = m30_fast; break;
         case 60:    Slow = h1_per; Fast = h1_fast; break;
         case 240:   Slow = h4_per; Fast = h4_fast; break;
         case 1440:  Slow = d_per;  Fast = d_fast; break;
         case 10080: Slow = w_per;  Fast = w_fast; break;
         case 43200: Slow = mn_per; Fast = mn_fast; break;
       }
 //----  
     for(int i=0; i<limit; i++){
      //  
      
      if (EUR){double EURUSD_Fast=ma("EURUSD",Fast,MA_Method,Price2,i);double EURUSD_Slow=ma("EURUSD",Slow,MA_Method,Price2,i);if (!EURUSD_Fast || !EURUSD_Slow)break;}
      if (GBP){double GBPUSD_Fast=ma("GBPUSD",Fast,MA_Method,Price2,i);double GBPUSD_Slow=ma("GBPUSD",Slow,MA_Method,Price2,i);if (!GBPUSD_Fast || !GBPUSD_Slow)break;}
      if (CHF){ double USDCHF_Fast=ma("USDCHF",Fast,MA_Method,Price2,i);double USDCHF_Slow=ma("USDCHF",Slow,MA_Method,Price2,i);if (!USDCHF_Fast || !USDCHF_Slow)break;}
      if (JPY){double USDJPY_Fast=ma("USDJPY",Fast,MA_Method,Price2,i)/100;double USDJPY_Slow=ma("USDJPY",Slow,MA_Method,Price2,i)/100;if (!USDJPY_Fast || !USDJPY_Slow)break;}
      //  
      if (USD){
         arrUSD[i]=0;
         if (EUR) arrUSD[i]+=EURUSD_Slow-EURUSD_Fast;
         if (GBP) arrUSD[i]+=GBPUSD_Slow-GBPUSD_Fast;
         if (CHF) arrUSD[i]+=USDCHF_Fast-USDCHF_Slow;
         if (JPY) arrUSD[i]+=USDJPY_Fast-USDJPY_Slow;
      }// end if USD
      if (EUR){
         arrEUR[i]=0;
         if (USD) arrEUR[i]+=EURUSD_Fast-EURUSD_Slow;
         if (GBP) arrEUR[i]+=(EURUSD_Fast/GBPUSD_Fast-EURUSD_Slow/GBPUSD_Slow)*ma("EURUSD",1,MA_Method,Price2,i);
         if (CHF) arrEUR[i]+=(EURUSD_Fast*USDCHF_Fast-EURUSD_Slow*USDCHF_Slow)*ma("EURUSD",1,MA_Method,Price2,i);
         if (JPY) arrEUR[i]+=(EURUSD_Fast*USDJPY_Fast-EURUSD_Slow*USDJPY_Slow)*ma("EURUSD",1,MA_Method,Price2,i);
      }// end if EUR
      if (GBP){
         arrGBP[i]=0;
         if (USD) arrGBP[i]+=GBPUSD_Fast-GBPUSD_Slow;
         if (EUR) arrGBP[i]+=(EURUSD_Slow/GBPUSD_Slow-EURUSD_Fast/GBPUSD_Fast)*ma("GBPUSD",1,MA_Method,Price2,i);
         if (CHF) arrGBP[i]+=(GBPUSD_Fast*USDCHF_Fast-GBPUSD_Slow*USDCHF_Slow)*ma("GBPUSD",1,MA_Method,Price2,i);
         if (JPY) arrGBP[i]+=(GBPUSD_Fast*USDJPY_Fast-GBPUSD_Slow*USDJPY_Slow)*ma("GBPUSD",1,MA_Method,Price2,i);
      }// end if GBP        
      if (CHF){
         arrCHF[i]=0;
         if (USD) arrCHF[i]+=USDCHF_Slow-USDCHF_Fast;
         if (EUR) arrCHF[i]+=(EURUSD_Slow*USDCHF_Slow-EURUSD_Fast*USDCHF_Fast)*ma("USDCHF",1,MA_Method,Price2,i);
         if (GBP) arrCHF[i]+=(GBPUSD_Slow*USDCHF_Slow-GBPUSD_Fast*USDCHF_Fast)*ma("USDCHF",1,MA_Method,Price2,i);
         if (JPY) arrCHF[i]+=(USDJPY_Fast/USDCHF_Fast-USDJPY_Slow/USDCHF_Slow)*ma("USDCHF",1,MA_Method,Price2,i);
      }// end if CHF
      if (JPY){
         arrJPY[i]=0;
         if (USD) arrJPY[i]+=USDJPY_Slow-USDJPY_Fast;
         if (EUR) arrJPY[i]+=(EURUSD_Slow*USDJPY_Slow-EURUSD_Fast*USDJPY_Fast)*ma("USDJPY",1,MA_Method,Price2,i)/100;
         if (GBP) arrJPY[i]+=(GBPUSD_Slow*USDJPY_Slow-GBPUSD_Fast*USDJPY_Fast)*ma("USDJPY",1,MA_Method,Price2,i)/100;
         if (CHF) arrJPY[i]+=(USDJPY_Slow/USDCHF_Slow-USDJPY_Fast/USDCHF_Fast)*ma("USDJPY",1,MA_Method,Price2,i)/100;
      }// end if JPY
     
   
     
     kp[0]=(arrEUR[0]-arrEUR[1])-(arrUSD[0]-arrUSD[1]); vp[0]="EURUSD";// Eur/Usd      
     kp[1]=(arrEUR[0]-arrEUR[1])-(arrGBP[0]-arrGBP[1]); vp[1]="EURGBP";// Eur/Gbp         
     kp[2]=(arrEUR[0]-arrEUR[1])-(arrCHF[0]-arrCHF[1]); vp[2]="EURCHF";// Eur/Chf        
     kp[3]=(arrEUR[0]-arrEUR[1])-(arrJPY[0]-arrJPY[1]); vp[3]="EURJPY";// Eur/Jpy        
     kp[4]=(arrGBP[0]-arrGBP[1])-(arrUSD[0]-arrUSD[1]); vp[4]="GBPUSD";// Gbp/Usd         
     kp[5]=(arrGBP[0]-arrGBP[1])-(arrCHF[0]-arrCHF[1]); vp[5]="GBPCHF";// Gbp/Chf         
     kp[6]=(arrGBP[0]-arrGBP[1])-(arrJPY[0]-arrJPY[1]); vp[6]="GBPJPY";// Gbp/Jpy        
     kp[7]=(arrUSD[0]-arrUSD[1])-(arrCHF[0]-arrCHF[1]); vp[7]="USDCHF";// Usd/Chf         
     kp[8]=(arrUSD[0]-arrUSD[1])-(arrJPY[0]-arrJPY[1]); vp[8]="USDJPY";// Usd/Jpy
     kp[9]=(arrCHF[0]-arrCHF[1])-(arrJPY[0]-arrJPY[1]); vp[9]="CHFJPY"; // Chf/Jpy       
      
      for (int i2=0; i2<9; i2++){
        for (int j2=9; j2>i2; j2--){
           if (MathAbs(kp[j2-1])<MathAbs(kp[j2]))
           {
            x_buf_usk=kp[j2-1]; x_buf_vp=vp[j2-1];kp[j2-1]=kp[j2]; vp[j2-1]=vp[j2];kp[j2]=x_buf_usk; vp[j2]=x_buf_vp;
       } } }
     }//end block for(int i=0; i<limit; i++)
  //----     
     for (int b=1; b<Slow; b++){
     // Eur/Usd
     k=(arrEUR[b]-arrEUR[b+1])-(arrUSD[b]-arrUSD[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="EURUSD"; kob=b;}
     // Eur/Gbp    
     k=(arrEUR[b]-arrEUR[b+1])-(arrGBP[b]-arrGBP[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="EURGBP"; kob=b;}
     // Eur/Chf    
     k=(arrEUR[b]-arrEUR[b+1])-(arrCHF[b]-arrCHF[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="EURCHF"; kob=b;}
     // Eur/Jpy    
     k=(arrEUR[b]-arrEUR[b+1])-(arrJPY[b]-arrJPY[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="EURJPY"; kob=b;}
     // Gbp/Usd    
     k=(arrGBP[b]-arrGBP[b+1])-(arrUSD[b]-arrUSD[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="GBPUSD"; kob=b;}
     // Gbp/Chf    
     k=(arrGBP[b]-arrGBP[b+1])-(arrCHF[b]-arrCHF[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="GBPCHF"; kob=b;}
     // Gbp/Jpy
     k=(arrGBP[b]-arrGBP[b+1])-(arrJPY[b]-arrJPY[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="GBPJPY"; kob=b;}
     // Usd/Chf    
     k=(arrUSD[b]-arrUSD[b+1])-(arrCHF[b]-arrCHF[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="USDCHF"; kob=b;}
     // Usd/Jpy    
     k=(arrUSD[b]-arrUSD[b+1])-(arrJPY[b]-arrJPY[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="USDJPY"; kob=b;}
     // Chf/Jpy    
     k=(arrCHF[b]-arrCHF[b+1])-(arrJPY[b]-arrJPY[b+1]);if (MathAbs(k)>MathAbs(max_k_sl)) {max_k_sl=k; para_f="CHFJPY"; kob=b;}
      
       }
       
  for (int i3=0; i3<=19; i3++){ob_f="ob"+DoubleToStr(i3,0);ObjectDelete(ob_f);} 
  for (int i4=0; i4<=9; i4++){
       ob_f="ob"+DoubleToStr(i4,0); 
        ObjectCreate(ob_f, OBJ_LABEL, 0, 0, 0);ObjectSet(ob_f, OBJPROP_CORNER, 1);ObjectSet(ob_f, OBJPROP_XDISTANCE, 45);ObjectSet(ob_f, OBJPROP_YDISTANCE, 2+i4*14);
        col_tek=color_val;if (Symbol()==vp[i4]) col_tek=DarkOrange; ObjectSetText(ob_f, vp[i4], 8, "Arial ", col_tek);ob_f2="ob"+DoubleToStr(i4+10,0);usk=DoubleToStr(kp[i4],4);  
        
       if (kp[i4]>0) wt=Lime; else wt=Red;
        ObjectCreate(ob_f2, OBJ_LABEL, 0, 0, 0);ObjectSet(ob_f2, OBJPROP_CORNER, 1);
        ObjectSet(ob_f2, OBJPROP_XDISTANCE, 7);ObjectSet(ob_f2, OBJPROP_YDISTANCE, 2+i4*14);ObjectSetText(ob_f2, usk, 8, "Arial ", wt);
       }         
       
        ObjectDelete("ob_fv"); ObjectDelete("ob_fa"); ObjectDelete("kob");
        ObjectCreate("ob_fv", OBJ_LABEL, 0, 0, 0);ObjectSet("ob_fv", OBJPROP_CORNER, 1);ObjectSet("ob_fv", OBJPROP_XDISTANCE, 130);
        ObjectSet("ob_fv", OBJPROP_YDISTANCE, 2);ObjectSetText("ob_fv", para_f, 8, "Arial", Black);
        
        if (max_k_sl>0) wt=Lime; else wt=Red;
        ObjectCreate("ob_fa", OBJ_LABEL, 0, 0, 0);ObjectSet("ob_fa", OBJPROP_CORNER, 1);ObjectSet("ob_fa", OBJPROP_XDISTANCE, 90);
        ObjectSet("ob_fa", OBJPROP_YDISTANCE, 2);ObjectSetText("ob_fa", DoubleToStr(max_k_sl,4), 8, "Arial", wt);
        ObjectCreate("kob", OBJ_LABEL, 0, 0, 0);ObjectSet("kob", OBJPROP_CORNER, 1);
        ObjectSet("kob", OBJPROP_XDISTANCE, 175);ObjectSet("kob", OBJPROP_YDISTANCE, 2);ObjectSetText("kob", DoubleToStr(kob,0), 8, "Arial", Red);
    
   return(0);
  }
//+------------------------------------------------------------------+

// Subroutines
double ma(string sym, int per, int Mode, int Price2, int i){
   return(iMA(sym,0,per,0,Mode,Price2,i));
}   

void sl(string sym, int y, color col){
   int window=WindowFind(Indicator_Name);string ID=Indicator_Name+Objs;Print("ID:",ID);int tmp=10+y;Objs++;
   if (ObjectCreate(ID, OBJ_LABEL, window, 0, 0)){ObjectSet(ID, OBJPROP_XDISTANCE, y+35);ObjectSet(ID, OBJPROP_YDISTANCE, 0);ObjectSetText(ID, sym, 8, "Arial", col);}
}   
   

   


